=== debian/changelog ===
x265 (2.4-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/control:
    - Bump Standards-Version. Support for DEB_BUILD_OPTIONS=nodoc is deferred
      until debhelper supports it (#865707).
    - Use Python3 version of sphinx.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 26 Jun 2017 18:27:41 +0200

x265 (2.4-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: 110 -> 116.
  * debian/patches: Refresh.
  * debian/copyright: Regenerate using decopy.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 26 Apr 2017 22:29:34 +0200
