=== debian/changelog ===
x265 (2.5-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 15 Aug 2017 20:08:02 +0200

x265 (2.5-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: 116 -> 130.
  * debian/patches: Refresh.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 19 Jul 2017 20:03:28 +0200
