## x265 2.6

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 130)
+set(X265_BUILD 146)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -184,6 +184,14 @@
 endif()
 # this option is to enable the inclusion of dynamic HDR10 library to the libx265 compilation
 option(ENABLE_HDR10_PLUS "Enable dynamic HDR10 compilation" OFF)
+if(MSVC AND (MSVC_VERSION LESS 1800) AND ENABLE_HDR10_PLUS)
+    message(FATAL_ERROR "MSVC version 12.0 or above required to support hdr10plus")
+endif()
+if(WIN32 AND (MSVC_VERSION GREATER 1800))
+    if(CMAKE_VERSION VERSION_LESS 3.7)
+        message(FATAL_ERROR "cmake version not compatible for VS 2017. Update the cmake to versions 3.7 or above")
+    endif()
+endif()
 if(GCC)
     add_definitions(-Wall -Wextra -Wshadow)
     add_definitions(-D__STDC_LIMIT_MACROS=1)
@@ -311,12 +319,3 @@
                 list(APPEND PLATFORM_LIBS ssp)
             endif()
         endif()
-    endif(ENABLE_AGGRESSIVE_CHECKS)
-    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE CC_VERSION)
-endif(GCC)
-
-find_package(Yasm)
-if(ARM OR CROSS_COMPILE_ARM)
-    option(ENABLE_ASSEMBLY "Enable use of assembly coded primitives" ON)
-elseif(YASM_FOUND AND X86)
-    if (YASM_VERSION_STRING VERSION_LESS "1.2.0")
