=== debian/changelog ===
x265 (2.6-3) unstable; urgency=medium

  * debian/patches: Fix possible NULL pointer in cudata init. (CVE-2017-13135)
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 31 Dec 2017 13:14:43 +0100

x265 (2.6-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 06 Dec 2017 23:56:19 +0100

x265 (2.6-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: 130 -> 146.
  * debian/control: Bump Standards-Version.
  * debian/copyright: Update copyright info.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 03 Dec 2017 21:20:48 +0100
