## x265 2.7

=== debian/changelog ===
x265 (2.7-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 28 Apr 2018 15:26:41 +0200

x265 (2.7-1) experimental; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Jonathon Fernyhough ]
  * New upstream release.
  * SONAME bump: 146 -> 151.
  * debian/control: switch from yasm to nasm.
  * Drop patch 0003-Fix-possible-NULL-pointer, included upstream.

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump Standards-Version. No changes required.
    - Bump nasm version to match cmake check.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 17 Apr 2018 20:15:38 +0200
