=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: x265
 Section: video
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11),
  cmake,
  libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
- yasm (>= 1.2) [amd64 kfreebsd-amd64]
+ nasm (>= 2.13) [amd64 kfreebsd-amd64]
 Build-Depends-Indep:
  python3-sphinx
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://x265.org
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/x265.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/x265.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
 
 Package: x265
 Architecture: any
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-146 (= ${binary:Version})
+ libx265-151 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-146
+Package: libx265-151
 Section: libs
 Architecture: any
 Multi-Arch: same
