=== debian/changelog ===
x265 (2.8-3~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 21 Jun 2018 10:47:40 -0700

x265 (2.8-3) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 12 Jun 2018 09:40:47 +0200

x265 (2.8-2) experimental; urgency=medium

  * debian/patches: Apply upstream patch to fix build on non-x86
    architectures.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 11 Jun 2018 21:24:20 +0200

x265 (2.8-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: 151 -> 160.
  * debian/rules: Install upstream changelog.
  * debian/patches: Refresh patches.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 May 2018 22:28:12 +0200

x265 (2.7-3) unstable; urgency=medium

  * debian/libx265-doc.doc-base: Fix paths.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 20 May 2018 14:03:43 +0200
