=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: x265
 Section: video
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
  debhelper (>= 11),
@@ -43,7 +44,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-151 (= ${binary:Version})
+ libx265-160 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +54,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-151
+Package: libx265-160
 Section: libs
 Architecture: any
 Multi-Arch: same
