=== debian/rules ===
--- 
+++ 
@@ -87,3 +87,6 @@
 override_dh_installdocs-indep:
 	dh_installdocs
 	dh_sphinxdoc
+
+override_dh_installchangelogs:
+	dh_installchangelogs doc/reST/releasenotes.rst
